#version 450 core

layout (location = 0) out vec4 FragColor;

in vec3 v_Normal;
in vec2 v_TexCoord;
in vec4 v_Vertex;

layout (binding = 0) uniform sampler2D       u_SceneTexture;
layout (location = 2) uniform vec4  u_LightPosition;

void main() {
    // Compute fragment diffuse color
    vec3 N      = normalize(v_Normal);
    vec3 L      = normalize(u_LightPosition.xyz - v_Vertex.xyz);
    float NdotL = max(dot(N, L), 0.0);
    FragColor  = texture(u_SceneTexture, v_TexCoord) * NdotL;
}
