#version 450 core

#ifdef USER_TEST
#endif

layout (binding = 0) uniform sampler2D u_warpX;
layout (binding = 1) uniform sampler2D u_warpY;

layout (location = 0) uniform mat4  u_PVMMatrix;
layout (location = 1) uniform float u_resolution;

layout (location = 0) in vec4 a_Vertex;

void main(void) {
    vec4 v_LightSpacePos = u_PVMMatrix * a_Vertex;

    // we want to transform the vertex - to rasterize more fragments
    // in the "important" areas, vertices are moved according to the warp 
    vec2 coord = v_LightSpacePos.xy;
    coord.xy = coord.xy / v_LightSpacePos.w;
    coord.xy = coord.xy * 0.5 + 0.5;

    // read warp values in light screen space
    float valX = texture(u_warpX, vec2(coord.x, 0.5)).r - texture(u_warpX, vec2(coord.x, 0.5)).g;
    float valY = texture(u_warpY, vec2(coord.y, 0.5)).r - texture(u_warpY, vec2(coord.y, 0.5)).g;
    coord.x += valX;
    coord.y += valY;
    // go back
    coord.xy = coord.xy * 2.0 - 1.0;
    coord.xy = coord.xy * v_LightSpacePos.w;
    v_LightSpacePos.xy = coord.xy;
    gl_Position.xyzw     = v_LightSpacePos.xyzw;
}
